/*
 * Copyright 2019 lorislab.org.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.lorislab.mp.client.rs;

import org.eclipse.microprofile.rest.client.RestClientBuilder;
import org.eclipse.microprofile.rest.client.inject.RestClient;
import org.lorislab.mp.client.api.TestRestService;

import javax.ejb.Stateless;
import javax.inject.Inject;
import javax.ws.rs.GET;
import javax.ws.rs.Path;
import java.net.URL;

@Stateless
@Path("test")
public class TestServiceBean {

    @Inject
    @RestClient
    private TestRestService testService;

    @GET
    @Path("1")
    public String test() {
        try {
            System.out.println("@Inject @RestClient TestRestService");
            String tmp = testService.get();
            System.out.println(tmp);
        } catch (Exception e) {
            e.printStackTrace();
            return "ERROR";
        }
        return "OK";
    }

    @GET
    @Path("2")
    public String test2() {
        try {
            System.out.println("RestClientBuilder TestRestService");
            TestRestService service = RestClientBuilder.newBuilder()
                    .baseUrl(new URL("https://jsonplaceholder.typicode.com"))
                    .build(TestRestService.class);
            String tmp = service.get();
            System.out.println(tmp);
        } catch (Exception e) {
            e.printStackTrace();
            return "ERROR";
        }
        return "OK";
    }
}
